/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.ParamCompraPuntoDAO;
import com.rjconsultores.ventaboletos.entidad.ParamCompraPunto;
import com.rjconsultores.ventaboletos.service.ParamCompraPuntoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.math.BigDecimal;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Rafius
 */
@Service("paramCompraPuntoService")
public class ParamCompraPuntoServiceImpl implements ParamCompraPuntoService {

    @Autowired
    private ParamCompraPuntoDAO paramCompraPuntoDAO;

    public List<ParamCompraPunto> obtenerTodos() {
        return paramCompraPuntoDAO.obtenerTodos();
    }

    public ParamCompraPunto obtenerID(Integer id) {
        return paramCompraPuntoDAO.obtenerID(id);
    }

    @Transactional
    public ParamCompraPunto suscribir(ParamCompraPunto entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return paramCompraPuntoDAO.suscribir(entidad);
    }

    @Transactional
    public ParamCompraPunto actualizacion(ParamCompraPunto entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return paramCompraPuntoDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(ParamCompraPunto entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        paramCompraPuntoDAO.actualizacion(entidad);
    }

    public List<ParamCompraPunto> buscar(Date ini, Date fim) {
        return paramCompraPuntoDAO.buscar(ini, fim);
    }

    public List<ParamCompraPunto> buscar(Date ini, Date fim, Integer cantPuntos, BigDecimal costoPunto) {
        return paramCompraPuntoDAO.buscar(ini, fim, cantPuntos, costoPunto);
    }
}
